import java.awt.*;

public class Messenger2 extends Input implements Runnable{
	String mess;
	int ii[] = new int[4];
	int iixy[] = new int[2];
	int x=0;
	int nx,ny,ixioff;

 	Thread messenger=null;

 	Image ioff;
 	Graphics goff;

	public void init(){
		String fnt;
		int jj[] = new int[3];
		int ifnt[] = new int[2];

		mess = getMess();
		ii = getRGB();
		jj = getBackColor();
		fnt = getFntName();
		ifnt = getFntAttrib();
		iixy = getFrameSize();
		int ifntmin = (int)(iixy[1]/0.9);
		if(ifnt[1] > ifntmin)ifnt[1] = ifntmin;

		Font font = new Font(fnt,ifnt[0],ifnt[1]);
		FontMetrics fm = getFontMetrics(font);
		int itextw = fm.stringWidth(mess);
		nx = (int)(iixy[0]*Math.random()/2); 
		ny = (int)(iixy[1]/2+ifnt[1]*0.35);
		Color col = new Color(jj[0],jj[1],jj[2]);
		setBackground(col);
		if(iixy[0] < (itextw + iixy[0] * 0.01 + nx)){
			ixioff = (int)(itextw + iixy[0] * 0.01 + nx); 
		}else ixioff = iixy[0];
		ioff = createImage(ixioff,iixy[1]*2);
		goff = ioff.getGraphics();
		goff.setColor(getBackground());
		goff.fillRect(0,0,ixioff,iixy[1]*2);
		goff.setFont(font);
	}

	public static void main(int iixy[],String args[]){
		Frame f = new Frame("Messenger2");
		Messenger2 dd = new Messenger2();
		dd.init();
		dd.start();
		f.add("Center",dd);
		f.resize(iixy[0],iixy[1]);
		f.show();
	}

	public synchronized boolean mouseDown(Event evt,int x, int y){
		if(messenger == null){
			messenger = new Thread(this);
			messenger.start();
		}else{
			messenger.stop();
			messenger = null;
		}
		return true;
	}
	public void start(){
		if(messenger == null){
			messenger = new Thread(this);
			messenger.start();
		}
	}
   
	public void stop(){
		if(messenger != null){
			messenger.stop();
			messenger = null;
		}
	}

 	public void run(){
		while(messenger.isAlive()){
			repaint();
			try{
				messenger.sleep(100);
			} catch(InterruptedException e){
				break;
			}
		}
	}

	public void update(Graphics g){
		paint(g);
		x = (x + 3) % ixioff;
	}

	public void paint(Graphics g){
		if(ii[3] == -1){
			ii[0] = (int)(Math.random()*256);
			ii[1] = (int)(Math.random()*256);
			ii[2] = (int)(Math.random()*256);
		}
		Color color = new Color(ii[0],ii[1],ii[2]); 
		goff.setColor(color);
		goff.drawString(mess,nx,ny);
		if(x > nx){
			goff.copyArea(nx,0,x - nx,iixy[1],ixioff - x,iixy[1]);
		}
			goff.copyArea(x,0,ixioff - x,iixy[1],-x,iixy[1]);
		g.drawImage(ioff,0,-iixy[1],this);
	}
}
